<?
include("common.php");

$l = array(0.20, 0.35, 0.35, 0.10); // initial values of lambdas
if (!$heldout) $heldout = 40000; // number of words in Heldout Data
if (!$test) $test = 20000; // number of words in Test Data
if (!$precision) $precision = 0.01; // precission of smoothing
$tweaks = array(0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 95, 99, -10, -20, -30, -40, -50, -60, -70, -80, -90, -100); // boosting values of trigram paramter (in %)
$format = "%1.".round(-log10($precision) + 2)."f"; // print format of lambdas

$filename = "TEXTEN1.txt"; $l = array(0.10, 0.23, 0.45, 0.22);
//$filename = "TEXTCZ1.txt"; $l = array(0.26, 0.37, 0.20, 0.17);
$tweaks = array(0);

echo "Filename:\t$filename\n";
echo "Precission:\t$precision\n";
print_time("Started");

$file = file($filename);

if ($filename == "small.txt") { // adjust number of words for testing
	$heldout = count($file) / 5;
	$test = count($file) / 10;
}

print_time("File loaded");

$unigram = $trigram = array();
$line0 = $line1 = " ";
$lines = count($file) - $heldout - $test;
for ($i=0; $i < $lines; $i++) {
	$line = trim($file[$i]);
	$unigram[$line1]++;
	// $bigram[$word1][$word2] == array_sum($trigram[$word1][$word2]) - array_sum is faster and smaller than $bigram
	$trigram[$line1][$line0][$line]++;
	$line1 = $line0;
	$line0 = $line;
}
$last_words = array($line0, $line1);
print_time("Training n-grams made");

/*
$trigram_h = array();
list($line0, $line1) = $last_words;
for ($i=$lines; $i < $lines + $heldout; $i++) {
	$line = trim($file[$i]);
	$trigram_h[$line1][$line0][$line]++;
	$line1 = $line0;
	$line0 = $line;
}
print_time("Heldout n-grams made");

$cl_one = array(0, 0, 0, 0); // counter for each lambda in one step
for ($exp=1; 1-max($l) > $precision; $exp++) {
	$cl = array(0, 0, 0, 0); // counter for each lambda
	foreach ($trigram_h as $word1 => $unigrams_h) foreach ($unigrams_h as $word2 => $bigrams_h) foreach ($bigrams_h as $word3 => $count) {
		$cl_one[0] = $l[0] / count($unigram);
		$cl_one[1] = $l[1] * $unigram[$word3] / $lines;
		$cl_one[2] = $l[2] * ($unigram[$word2] ? @array_sum($trigram[$word2][$word3]) / $unigram[$word2] : $unigram[$word3] / $lines); // after ":" should be 1 / count($unigram)
		$cl_one[3] = $l[3] * ($trigram[$word1][$word2] ? $trigram[$word1][$word2][$word3] / array_sum($trigram[$word1][$word2]) : $cl_one[2] / $l[2]); // after ":" should be 1 / count($unigram)
		for ($i=0; $i <= 3; $i++) $cl[$i] += $count * $cl_one[$i] / array_sum($cl_one);
	}
	$l0 = $l; // old values of lambdas
	for ($i=1, $sum=0; $i <= 3; $i++) $sum += ($l[$i] = $cl[$i] / array_sum($cl));
	$l[0] = 1 - $sum; // to be sure that sum is 1
	print_time(sprintf("$format\t$format\t$format\t$format", $l[0], $l[1], $l[2], $l[3]));
	for ($i=0; $i <= 3; $i++) if (abs($l0[$i] - $l[$i]) > $precision) break; // break if some labda is not precise enough
	if ($i == 4) break; // break only if all lambdas are precise enough
}
*/

$unigram_t = $trigram_t = array();
for ($i=$lines + $heldout; $i < $lines + $heldout + $test; $i++) {
	$line = trim($file[$i]);
	$unigram_t[$line1]++;
	$trigram_t[$line1][$line0][$line]++;
	$line1 = $line0;
	$line0 = $line;
}
print_time("Test n-grams made");

$coverage = array(0, 0, 0);
$reliability = array(0, 0, 0);
$reliability_count = array(0, 0, 0);
foreach ($trigram_t as $word1 => $unigrams_t) {
	if ($trigram[$word1]) $coverage[0] += $unigram_t[$word1];
	$reliability_count[0]++; $reliability[0] += $unigram_t[$word1] * $unigram[$word1] / $lines;
	foreach ($unigrams_t as $word2 => $bigrams_t) {
		if ($trigram[$word1][$word2]) $coverage[1] += array_sum($bigrams_t);
		if ($trigram[$word1]) { $reliability_count[1]++; $reliability[1] += array_sum($bigrams_t) * @array_sum($trigram[$word1][$word2]) / $unigram[$word1]; }
		foreach ($bigrams_t as $word3 => $count) {
			if ($trigram[$word1][$word2][$word3]) $coverage[2] += $count;
			if ($trigram[$word1][$word2]) { $reliability_count[2]++; $reliability[2] += $count * $trigram[$word1][$word2][$word3] / array_sum($trigram[$word1][$word2]); }
		}
	}
}
echo "\n\tcoverage\treliability\n";
printf("Unigram\t$format\t$format\n", $coverage[0] / $test, ($reliability_count[0] ? $reliability[0] / $reliability_count[0] : 0));
printf("Bigram\t$format\t$format\n", $coverage[1] / $test, ($reliability_count[1] ? $reliability[1] / $reliability_count[1] : 0));
printf("Trigram\t$format\t$format\n", $coverage[2] / $test, ($reliability_count[2] ? $reliability[2] / $reliability_count[2] : 0));

$l0 = $l;
echo "\nTweak\tlambda0\tlambda1\tlambda2\tlambda3\tEntropy\tTime\n";
foreach ($tweaks as $tweak) {
	if ($tweak == 0) $l = $l0;
	else {
		if ($tweak > 0) $l[3] = $l0[3] + (1-$l0[3]) * $tweak / 100;
		else $l[3] = $l0[3] * (1 + $tweak / 100);
		$sum = $l[3];
		for ($i=1; $i < 3; $i++) $sum += $l[$i] = $l0[$i] * ((1-$l[3]) / (1-$l0[3]));
		$l[0] = 1 - $sum;
	}
	
	printf("$tweak%%\t$format\t$format\t$format\t$format\t", $l[0], $l[1], $l[2], $l[3]);
	$entropy = 0;
	foreach ($trigram_t as $word1 => $unigrams_t) foreach ($unigrams_t as $word2 => $bigrams_t) foreach ($bigrams_t as $word3 => $count) {
		$cl_one[0] = $l[0] / count($unigram);
		$cl_one[1] = $l[1] * $unigram[$word3] / $lines;
		$cl_one[2] = $l[2] * ($unigram[$word2] ? @array_sum($trigram[$word2][$word3]) / $unigram[$word2] : $unigram[$word3] / $lines); // after ":" should be 1 / count($unigram)
		$cl_one[3] = $l[3] * ($trigram[$word1][$word2] ? $trigram[$word1][$word2][$word3] / array_sum($trigram[$word1][$word2]) : $cl_one[2] / $l[2]); // after ":" should be 1 / count($unigram)
		$entropy -= ($count / $test) * log2(array_sum($cl_one));
	}
	printf("%1.4f\t", $entropy);
	print_time();
}
?>
